2015-06-22  Michael Sperber  <mike@xemacs.org>

	* lwlib-colors.h: 
	* lwlib-colors.c (xft_convert_color_1): Introduce, and make
	`xft_convert_color' use it.

2015-01-07  Jerry James  <james@xemacs.org>
 
	* lwlib-Xaw.c (xaw_scrollbar_scroll): Add typecast to fix g++ build,
	problem reported by Marcus Harnisch.

2015-01-08  Stephen J. Turnbull  <stephen@xemacs.org>

	Fix progress bar crashes.
	Thanks to Ralf Soergel for diagnosis and a patch.

	* xt-wrappers.h (HAVE_ATHENA_I18N):
	Define XAW_INTERNATIONALIZATION when needed.

2013-06-23  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.34 "kale" is released.

2013-01-04  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.33 "horseradish" is released.

2012-08-02  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.32 "habanero" is released.

2011-05-20  Jerry James  <james@xemacs.org>

	* Makefile.in.in (DESTDIR): New variable for all Makefiles, unused in
	this one.

2011-04-29  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.31 "ginger" is released.

2011-04-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.30 "garlic" is released.

2011-01-11  Aidan Kehoe  <kehoea@parhasard.net>

	* lwlib-fonts.c (xft_open_font_by_name):
	Replace the POSIX index(3), not universally available even today,
	with the C89 strchr(3), hopefully fixing a few of the buildbots'
	problems.

2010-06-13  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib-internal.h: Correct FSF address in permission notice.

2010-02-22  Ben Wing  <ben@xemacs.org>

	* lwlib-colors.h:
	objects*.h -> fontcolor*.h.

2010-02-08  Ben Wing  <ben@xemacs.org>

	* xt-wrappers.h:
	* xt-wrappers.h (Xt_SET_VALUE):
	* xt-wrappers.h (Xt_GET_VALUE):
	Rename var to avoid shadowing problems.

2010-01-24  Ben Wing  <ben@xemacs.org>

	* xlwgauge.c (GaugeResize):
	* xlwgauge.c (GaugeSize):
	Fix warnings about possible use of uninitialized vars.

2010-02-01  Ben Wing  <ben@xemacs.org>

	* lwlib-colors.c:
	* lwlib-colors.h:
	* lwlib-fonts.c:
	* lwlib-fonts.h:
	* xlwmenu.c:
	* xlwmenu.c (xlwMenuResources):
	* xlwmenu.c (x_xft_text_width):
	* xlwmenu.c (label_button_draw):
	* xlwmenu.c (push_button_size):
	* xlwmenu.c (push_button_draw):
	* xlwmenu.c (make_drawing_gcs):
	* xlwmenu.c (extract_font_extents):
	* xlwmenu.c (default_font_of_font_list):
	* xlwmenu.c (XlwMenuInitialize):
	* xlwmenu.c (XlwMenuDestroy):
	* xlwmenu.c (XlwMenuSetValues):
	* xlwmenuP.h:
	* xlwmenuP.h (_XlwMenu_part):
	* xlwtabs.c:
	* xlwtabs.c (TabsInit):
	* xlwtabs.c (TabsDestroy):
	* xlwtabs.c (TabsSetValues):
	* xlwtabs.c (DrawTab):
	* xlwtabs.c (TabWidth):
	* xlwtabs.c (TabsAllocFgGC):
	* xlwtabs.c (TabsAllocGreyGC):
	* xlwtabsP.h:
	USE_XFT* -> HAVE_XFT*.

2010-01-28  Jerry James  <james@xemacs.org>

	* lwlib-internal.h: Add copyright and license boilerplate text
	based on Ben's recollections.

2009-12-09  Jerry James  <james@xemacs.org>

	* lwlib-Xlw.c: Include needed Xmu headers instead of obsolete xmu.h.
	* xlwcheckbox.c: Ditto.
	* xlwradio.c: Ditto.
	* xlwgauge.c: Ditto.  Unconditionally include HAVE_XMU code.
	* xlwtabs.c: Ditto.
	* xlwgcs.c: Ditto.  Remove pre-X11R5 code.
	* xlwgcs.h: Remove pre-X11R5 declarations.

2009-11-10  Jerry James  <james@xemacs.org>

	* lwlib.c: Drop workaround for old NeXT systems.

2009-05-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.29 "garbanzo" is released.

2008-11-02  Stephen J. Turnbull  <stephen@xemacs.org>

	G++ 4.3 complains a lot about implicit conversions of string
	literals (const char *) to char *.  Shut it up.

	* xt-wrappers.h: New file.
	Contains wrappers for Xt functions and macros for C++
	type-correctness and/or convenience.

	* lwlib.h:
	* lwlib-Xm.c:
	* lwlib-Xaw.c:
	#include xt-wrappers.h.

	* xlwcheckbox.c:
	* xlwgauge.c:
	* xlwmenu.c:
	* xlwradio.c:
	* xlwscrollbar.c:
	* xlwtabs.c:
	#include xt-wrappers.h.
	Cast class name to String.
	Cast action names to String.
	Rewrite resources to use Xt_RESOURCE.

	* lwlib.h (lw_get_value_arg):
	* lwlib.c (lw_get_value_arg):
	Declare String argument const.

	* lwlib-Xaw.c (xaw_actions):
	Cast to string.

	* lwlib-Xaw.c (xaw_update_scrollbar):
	* lwlib-Xaw.c (xaw_update_one_widget):
	* lwlib-Xaw.c (xaw_update_one_value):
	* lwlib-Xaw.c (make_dialog):
	* lwlib-Xaw.c (xaw_generic_callback):
	* lwlib-Xaw.c (wm_delete_window):
	* lwlib-Xaw.c (xaw_create_scrollbar):
	* lwlib-Xaw.c (xaw_create_button):
	* lwlib-Xaw.c (xaw_create_label):
	* lwlib-Xaw.c (xaw_create_progress):
	* lwlib-Xaw.c (xaw_create_text_field):
	* lwlib-Xaw.c (xaw_creation_table):
	* lwlib-Xlw.c (xlw_create_menubar):
	* lwlib-Xlw.c (xlw_create_popup_menu):
	* lwlib-Xlw.c (xlw_create_scrollbar):
	* lwlib-Xlw.c (xlw_update_scrollbar):
	* lwlib-Xlw.c (xlw_create_tab_control):
	* lwlib-Xlw.c (build_tabs_in_widget):
	* lwlib-Xlw.c (xlw_create_clip_window):
	* lwlib-Xlw.c (xlw_update_one_widget):
	* lwlib-Xm.c (xm_update_label):
	* lwlib-Xm.c (xm_update_pushbutton):
	* lwlib-Xm.c (xm_update_progress):
	* lwlib-Xm.c (xm_update_toggle):
	* lwlib-Xm.c (xm_update_radiobox):
	* lwlib-Xm.c (make_menu_in_widget):
	* lwlib-Xm.c (update_one_menu_entry):
	* lwlib-Xm.c (xm_update_scrollbar):
	* lwlib-Xm.c (xm_update_one_value):
	* lwlib-Xm.c (make_dialog):
	* lwlib-Xm.c (recenter_widget):
	* lwlib-Xm.c (recycle_instance):
	* lwlib-Xm.c (make_menubar):
	* lwlib-Xm.c (make_scrollbar):
	* lwlib-Xm.c (xm_create_button):
	* lwlib-Xm.c (xm_create_progress):
	* lwlib-Xm.c (xm_create_text_field):
	* lwlib-Xm.c (xm_create_label):
	* lwlib-Xm.c (xm_create_combo_box):
	* lwlib-Xm.c (xm_popup_menu):
	* lwlib-Xm.c (set_min_dialog_size):
	* lwlib-Xm.c (do_call):
	* lwlib-Xm.c (xm_generic_callback):
	* xlwcheckbox.c (offset):
	* xlwgauge.c (offset):
	* xlwgauge.c (actionsList):
	* xlwmenu.c (xlwMenuResources):
	* xlwmenu.c (xlwMenuActionsList):
	* xlwmenu.c (xlwMenuClassRec):
	* xlwmenu.c (nameResource):
	* xlwmenu.c (parameterize_string):
	* xlwradio.c (actionsList):
	* xlwscrollbar.c (offset):
	* xlwscrollbar.c (actions):
	Use Xt_SET_ARG, Xt_SET_VALUE, and Xt_GET_VALUE instead of raw Xt
	equivalents.

2008-10-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib-Xm.c (xm_update_progress): Set all values!

2007-09-15  Jerry James  <james@xemacs.org>

	* xlwmenu.c (XlwMenuDestroy): Release XftFont resources
	* xlwtabs.c (TabsDestroy): Ditto

2007-05-21  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.28 "fuki" is released.

2007-05-20  Stephen J. Turnbull  <stephen@xemacs.org>

	Gauge values are signed integers (ints).
	
	* xlwgauge.h: Get rid of references to Cardinal in comment.
	(XawGaugeGetValue): Declare return value as int.
	(XawGaugeSetValue): Declare value as int.

	* xlwgauge.c (GaugeGetValue): Declare value as int.
	(GaugeMercury): Declare val0 and val1 as int.  Remove redundant casts.
	(XawGaugeGetValue): Declare return value as int.
	(XawGaugeSetValue): Declare value as int.

2007-05-17  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib-Xaw.c (wm_delete_window): Iterate over children of shell
	(there may be more than one) to find our widget.

2006-11-17  Stephen J. Turnbull  <stephen@xemacs.org>

	* xlwmenu.c (xlwMenuResources):
	* xlwmenu.c (XlwMenuInitialize):
	* xlwmenuP.h (_XlwMenu_part):
	* xlwtabs.c (resources):
	* xlwtabs.c (TabsInit):
	* xlwtabsP.h (TabsPart):
	New xftFontName member in each widget part struct, corresponds to
	xftFont String resource.
	Initialize renderFont private member from fcFontName if non-NULL,
	otherwise initialize from xftFontName.

	* xlwtabs.h: Update parameter table.

2006-06-16  Jerry James  <james@xemacs.org>

	* lwlib-Xlw.c (xlw_scrollbar_callback): Do not dereference
	instance before checking whether it is NULL.
	* xlwmenu.c (xlw_map_menu): Prevent uninitialized access to root
	and waste.

2006-05-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.27 "fiddleheads" is released.

2006-05-12  Stephen J. Turnbull  <stephen@xemacs.org>

	Make fcFontName and xftFont separate resources.

	* lwlib-fonts.h (XtNfcFontName, XtCFcFontName): New macros.
	(XtNxftFont, XtCXftFont): Coalesce the conditional definitions.

	* xlwmenuP.h (XlwMenuPart):
	* xlwtabsP.h (TabsPart):
	Rename renderFontSpec member to fcFontName.

	* xlwmenu.c (XlwMenuResources):
	* xlwtabs.c (resources):
	Add a record for fcFontName.

	* xlwtabs.c (TabsInit): Use the fcFontName resource, not xftFont.

	* xlwtabs.c (DrawTab,TabLayout,TabsGeometryManager): Improve
	diagnostics.

2006-04-24  Jerry James  <james@xemacs.org>

	* lwlib-Xaw.c (lw_debug_print_class_resources): Casting from a
	pointer to an int throws away half of the bits on an x86_64
	platform.  Print as a pointer instead.
	* xlwgauge.c (XawGaugeSetValue): Use NULL instead of 0 as the
	sentinel to quiet gcc warnings.
	* xlwmenu.c: Cast to FcChar8 * as necessary to quiet warnings.
	* xlwtabs.c: Ditto.

2006-04-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib-fonts.c: Change #include to "font-mgr.h".  Make
	conditional on HAVE_FONTCONFIG, not USE_XFT.

2006-03-31  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.26 "endive" is released.

2006-02-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.25 "eggplant" is released.

2005-12-21  Andrey Slusar  <anrays@gmail.com>

	* xlwmenu.c (make_drawing_gcs): Fix build with gcc 2.95.

2005-12-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.24 "dandelion" is released.

2005-11-26  Stephen J. Turnbull  <stephen@xemacs.org>

	Merge Xft.

    2005-11-25  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib-colors: Improve comments.
	
    2005-11-25  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib-colors: Remove or comment out dead code.
	
    2005-09-26 Olivier Galibert   <galibert@xemacs.org>

	* xlwmenu.c:
	* xlwmenuP.h:
	Give USE_XFT_MENUBARS priority over USE_MOTIF.

    2005-09-06  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib-fonts.c (xft_open_font_by_name): Fix heuristic for XLFDs.

	* xlwmenu.c (string_draw_range): Recommend persistent xftDraw.

    2005-09-02  Daniel Pittman <daniel@rimspace.net>

	* lwlib-fonts.c (xft_open_font_by_name): Eliminate code to avoid
	use of scaled fonts (probably bogus, anyway).  Add error message
	in case of fatal failure to find any fonts at all.
	<87ll2fucw1.fsf@rimspace.net>

	* xlwmenu.c (string_draw_range): Plug leak of XftDraw.

    2005-03-09  Stephen J. Turnbull  <stephen@xemacs.org>

	* xlwtabs.c (TabsGeometryManager): Fix "fat fingers" mistake.

    2005-03-07  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib-Xaw.c (debug_gauge): Fix and suppress gauge debug message.

	* xlwtabs.c (TabsGeometryManager): Suppress "kludging" message, too.
	(TabsGeometryManager): Make straight the paths of the layout, or
	at least improve the approximation to Xt conventions by 50%.

    2005-02-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* xlwtabs.c(debug_tabs): Suppress debug output for now.

    2005-02-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* xlwtabs.c (TabsGeometryManager,TabsQueryGeometry): Improve comments.
	(debug_tabs): New variable, substitute for debug_xft globally.
	(TabsGeometryManager): Substitute "request" for "req".

    2005-02-11  Stephen J. Turnbull  <stephen@xemacs.org>

	* xlwtabs.c (PreferredSize3): Let TabLayout choose constraints.
	(TabLayout): Default size to current size.  Fix header comment.
	(TabsGeometryManager): Comment on redesigning internal API.
	(TabsGeometryManager): Fix typo in format string.

    2005-01-27  Stephen J. Turnbull  <stephen@xemacs.org>

	* xlwtabs.c (DrawTab):
	Correct geometry when clearing rectangle.
	Remove some "check me" comments.
	Deemphasize a lot of debugging output.
	(TabLayout): Add debugging fprintf.
	(TabWidth): Deemphasize some debugging output.

    2004-12-10  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib-Xaw.c (xaw_create_button):
	(xaw_create_progress):
	(xaw_create_text_field):
	Changed XtCreateManagedWidget to XtCreateWidget when child is
	managed later in the same function.

	(debug_gauge): New variable.
	(lw_debug_print_xt_arglist):
	(lw_debug_print_class_resources):
	New debug functions.

    2004-12-09  Stephen J. Turnbull  <stephen@xemacs.org>

	* xlwmenu.c (xlwMenuResources): Use "redundant" XftFont resource.

	* xlwtabs.c:
	* xlwtabsP.h:
	Use USE_XFT_TABS consistently.

    2004-12-01  Stephen J. Turnbull  <stephen@xemacs.org>

	* xlwtabs.c: Move debug_xft to ../src/xft-fonts.c.

    2004-11-20  Stephen J. Turnbull  <stephen@xemacs.org>

	Xft branch based on "Xft reloaded #3" patch by Eric Knauel and
	Mathias Neuebaur, and other contributors.

	* lwlib-fonts.h:
	* lwlib-colors.h:
	Declare common facilities use by Xft.
	* lwlib-fonts.c:
	* lwlib-colors.c:
	Implement them.
	* xlwtabs.c:
	* xlwtabsP.h:
	* xlwmenu.c:
	* xlwmenuP.h:
	Implement Xft text drawing.

2005-11-22  Ben Wing  <ben@xemacs.org>

	* Makefile.in.in:
	Ignore errors from rm during clean.

2005-11-16  Stephen J. Turnbull  <stephen@xemacs.org>

	* xlwcheckbox.c (CheckboxInit): Mark unused parameters.  C++
	correctness.
	(CheckboxRealize): Don't compile at all if unused.

	* xlwradio.c (RadioDestroy): #if 0 dead code for later removal.

2005-11-13  Ben Wing  <ben@xemacs.org>

	* Makefile.in.in:
	Add targets distclean-noconfig, realclean-noconfig, extraclean-noconfig.
	Do some refactoring for cleanliness.

2005-11-08  Marcus Crestani  <crestani@xemacs.org>

	* xlwgauge.c (GaugeInit):
	* xlwgauge.c (GaugeSetValues):
	* xlwradio.c (RadioInit):
	* xlwradio.c (RadioSetValues): Rename new->new_.

2005-10-26  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.23 "daikon" is released.

2005-10-25  Ben Wing  <ben@xemacs.org>

	* lwlib-internal.h (assert):
	redo assert macros to follow lisp.h and not trigger warnings.
	
	* lwlib.c (merge_scrollbar_values):
	* lwlib.c (merge_widget_value_args):
	* xlwtabs.c:
	* xlwtabs.c (TabsInit):
	* xlwtabs.c (TabsConstraintInitialize):
	* xlwtabs.c (TabsSetValues):
	* xlwtabs.c (TabsConstraintSetValues):
	new -> new_.

2005-09-14  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.22 "cucumber" is released.

2005-05-28  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.21 "corn" is released.

2005-03-11  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.20 "cilantro" is released.

2005-03-07  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib-Xlw.c (build_tabs_in_widget): Correctly disable geometry
	negotiation for tab children.
	(xlw_create_tab_control): Don't set nonexistent resizable resource.

2005-02-18  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.19 "chives" is released.

2004-10-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.18 "chestnut" is released.

2004-09-27  Jerry James  <james@xemacs.org>

	* lwlib-Xm.c (xm_update_label):
	(xm_update_progress):
	(activate_button):
	(make_dialog):
	(mark_dead_instance_destroyed):
	(xm_nosel_callback):
	Mark more unused parameters with the UNUSED macro.

2004-09-14  Jerry James  <james@xemacs.org>

	* Makefile.in.in (cppflags): Make compiler.h available.
	* config.h.in: Include compiler.h.
	* lwlib.c (max): Remove; now defined in compiler.h.
	(merge_widget_value): Fix misplaced `change' computation.
	* xlwcheckbox.c (DrawCheck): conditionalize declaration and
	assignment of variable bw like its use.
	* xlwtabs.c (TabsResize): Comment out declaration and assignment
	of variable tab, whose use is commented out.

	* lwlib-Xaw.c:
	* lwlib-Xlw.c:
	* lwlib-Xm.c:
	* lwlib-utils.c:
	* lwlib.c:
	* xlwcheckbox.c:
	* xlwgauge.c:
	* xlwgcs.c:
	* xlwmenu.c:
	* xlwradio.c:
	* xlwscrollbar.c:
	* xlwtabs.c:
	Mark unused parameters with the UNUSED macro.

2004-09-14  Jerry James  <james@xemacs.org>

	* xlwgauge.c (GaugeConvert): Fix type-punning warning.

2004-04-23  Jerry James  <james@xemacs.org>

	* xlwradio.c (RadioExpose): Do not blindly copy one GC over
	another.  It messes up the ref counts and is wrong for radio
	buttons in any case.

2004-03-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.17 "chayote" is released.

2003-09-22  Stephen J. Turnbull  <stephen@xemacs.org>

	* Makefile.in.in (XE_CFLAGS): New variant on CFLAGS for XEMACS_CC.

2003-09-26  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.16 "celeriac" is released.

2003-09-03  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.15 "celery" is released.

2003-08-28  Jerry James  <james@xemacs.org>

	* lwlib-internal.h: Wrap assert_failed with EXTERN_C for modules.

2003-06-01  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.14 "cassava" is released.

2003-05-10  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.13 "cauliflower" is released.

2003-05-05  Steve Youngs  <youngs@xemacs.org>

	* lwlib-Xm.c (xm_update_one_widget): Only call
	`xm_update_progress' if `LWLIB_WIDGETS_MOTIF' is defined.

2003-04-24  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.12 "carrot" is released.

2003-03-27  Stephen J. Turnbull  <stephen@xemacs.org>

	* xlwscrollbar.c: Global substitution of .Xresources for .Xdefaults.

2003-02-28  Ben Wing  <ben@xemacs.org>

	* lwlib-Xm.c:
	Fix compile warning.

2003-02-16  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.11 "cabbage" is released.

2003-02-13  Martin Buchholz  <martin@xemacs.org>

	* xlwmenu.c (xlwMenuClassRec):
	Use symbolic name `XtExposeCompressMaximal' instead of `TRUE'.

2003-01-31  Martin Buchholz  <martin@xemacs.org>

	* lwlib-Xm.c (xm_update_progress): 
	Don't define unless LWLIB_WIDGETS_MOTIF.

2003-02-05  Ben Wing  <ben@xemacs.org>

	* lwlib-Xm.c:
	* lwlib-Xm.c (xm_pop_down_callback):
	* lwlib-Xm.c (xm_pull_down_callback):
	Fix compile warning.

2002-12-16  Ben Wing  <ben@xemacs.org>

	* lwlib-Xlw.c (xlw_update_one_widget):
	* lwlib-Xm.c (xm_update_one_widget):
	* lwlib-Xm.c (xm_update_one_value):
	* lwlib.c:
	* lwlib.c (merge_scrollbar_values):
	* xlwmenu.c:
	* xlwmenu.c (display_menu):
	* xlwmenu.c (XlwMenuInitialize):
	* xlwmenu.c (XlwMenuSetValues):
	* xlwradio.c:
	* xlwradio.c (RadioClassPartInit):
	* xlwradio.c (RadioSet):
	* xlwradio.c (RadioUnset):
	class -> class_, new -> new_.

2003-01-04  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.10 "burdock" is released.

2002-08-30  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.9 "brussels sprouts" is released.

2002-07-27  Steve Youngs  <youngs@xemacs.org>

	* XEmacs 21.5.8 "broccoli" is released.

2002-06-07  Andy Piper  <andy@xemacs.org>

	* lwlib-Xm.c: (xm_safe_update_label): new function. Call
	xm_update_label if the class is appropriate.
	(make_menu_in_widget): use it.
	(update_one_menu_entry): ditto.
	(xm_update_one_widget): ditto.

2002-07-02  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.7 "broccoflower" is released.

2002-06-20  Ben Wing  <ben@xemacs.org>

	* lwlib.c:
	* lwlib.c (dialog_spec_p): Fix warning.

2002-02-13  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib-Xm.c (make_dialog): Fix XmProcessTraversal crash.

2002-04-05  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.6 "bok choi" is released.

2002-03-12  Ben Wing  <ben@xemacs.org>

	* The Great Mule Merge of March 2002:
	see node by that name in the Internals Manual.

2002-03-05  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.5 "beets" is released.

2001-12-19  Valdis Kletnieks  <Valdis.Kletnieks@vt.edu>

	* xlwscrollbar.c: Fix Xt translations comment.
	
2002-01-08  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.4 "bamboo" is released.

2001-09-07  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.3 "asparagus" is released.

2001-06-24  Ben Wing  <ben@xemacs.org>

	* lwlib-Xlw.c (xlw_update_tab_control):
	* lwlib-utils.c (XtApplyUntilToWidgets):
	* xlwgauge.c (XawGaugeSetValue):
	* xlwgauge.c (GaugeMercury):
	* xlwmenu.c (close_to_reference_time):
	* xlwtabs.c (TabsSetValues):
	* xlwtabs.c (TabsSelect):
	* xlwtabs.c (DrawTabs):
	Fix unsigned warnings.  See src/ChangeLog for details.

2001-07-28  Stephen J. Turnbull  <stephen@xemacs.org>

	* XEmacs 21.5.2 "artichoke" is released.

2001-07-26  Andy Piper  <andy@xemacs.org>

	* lwlib-Xm.c (xm_update_progress): new function. Set Scale height
	and width from normal height and width.
	* lwlib-Xm.c (xm_create_progress): ditto.
	* lwlib-Xm.c (xm_update_one_widget): call xm_update_progress.
	* lwlib.c (lw_get_value_arg): new function. Return an argument
	based on its name.
	* lwlib.h: declare it.

2001-05-21  Martin Buchholz  <martin@xemacs.org>

	* lwlib-config.c: Remove.
	* Makefile.in.in: Remove references to lwlib-config.

2001-05-09  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.5.1 "anise" is released.

2001-04-28  Ben Wing  <ben@xemacs.org>

	* lwlib-utils.c (destroy_all_children): fix warning reported by
	Isaac Hollander <ysh@mindspring.com>.

2001-04-18  Martin Buchholz  <martin@xemacs.org>

	* XEmacs 21.5.0 "alfalfa" is released.

2001-03-30  Stephen J. Turnbull  <stephen@xemacs.org>

	* ChangeLog: Restore logs lost in the GTK merge.

2001-03-21  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.46 "Urania" is released.

2001-03-15  Stephen J. Turnbull  <stephen@xemacs.org>

	* xlwradio.c: Revert gratuitous whitespace changes from GTK merge.

2001-02-23  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.45 "Thelxepeia" is released.

2001-02-16  Raymond Toy  <toy@rtp.ericsson.se>

	* lwlib-Xaw.c: Always include ATHENA_AsciiText_h_ to get the
	text-field widget.
	(xaw_creation_table): Always include the text-field widget

2001-02-08  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.44 "Thalia" is released.

2001-02-06  Martin Buchholz  <martin@xemacs.org>

	* xlwgauge.c:
	* xlwgcs.c:
	* xlwgcs.c (XtAllocateGC): Fix typo for X11R4.
	* xlwgcs.h:
	* xlwradio.c (RadioExpose):
	* xlwcheckbox.c:
	Remove use of BSD-specific types.
	s/u_(char|short|int_long)/unsigned $1/g

2001-02-05  Martin Buchholz  <martin@xemacs.org>

	* lwlib-Xm.c (xm_update_one_value):
	Obey the man page; use XtFree instead of free.

2001-02-02  Martin Buchholz  <martin@xemacs.org>

	* config.h.in: Use "..." to include config.h

2001-01-26  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.43 "Terspichore" is released.

2001-01-20  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.42 "Poseidon" is released.

2001-01-17  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.41 "Polyhymnia" is released.

2001-01-08  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.40 is released.

2001-01-06  Martin Buchholz  <martin@xemacs.org>

	* lwlib-Xaw.c (xaw_creation_table): Make const.
	* lwlib-Xaw.h (xaw_creation_table): Make const.
	* lwlib-Xlw.c (xlw_creation_table): Make const.
	* lwlib-Xlw.h (xlw_creation_table): Make const.
	* lwlib-Xm.c (xm_creation_table): Make const.
	* lwlib-Xm.h (xm_creation_table): Make const.
	* lwlib.c (find_in_table): Use const.

2001-01-02  Andy Piper  <andy@xemacs.org>

	* lwlib.h (_widget_args): add args_changed. Necessary because we
	reference count args.

	* lwlib.c (lw_add_widget_value_arg): set args_changed flag.
	(merge_widget_value_args): mark as changed if args_changed is
	true.
	(update_all_widget_values): reset args_changed.
	(initialize_widget_instance): ditto.

2000-12-31  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.39 is released.

2000-12-30  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c: remove assertion definitions and put them in
	lwlib-internal.h. This has the effect of enabling assertions which
	should have been done from the very start.
	(TabsShuffleRows): fix duff assertion.
	(PreferredSize3): use dimensions throughout.
	(PreferredSize2): ditto.
	(TabLayout): ditto.
	(DrawFrame): be clever about the enclosing frame if the child
	height is 0.
	(TabsResize): don't configure children that are no visible
	anyway. Make sure geometry calculations don't end up negative.

	* lwlib-internal.h: put in assertion definitions.

2000-12-05  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.38 is released.

2000-11-30  Andy Piper  <andy@xemacs.org>

	* lwlib-Xm.c (xm_update_label): Hack to stop %_ labels until
	someone fixes it properly.

2000-11-24  Andy Piper  <andy@xemacs.org>

	* xlwtabsP.h: add visible flag, realRows and remove displayChildren.

	* xlwtabs.c (TabVisible): new macro. Consults visible flag.
	(TabsInit): remove displayChildren, add realRows.
	(TabsConstraintInitialize): ditto.
	(TabsResize): ditto.
	(TabsGeometryManager): ditto.
	(TabsChangeManaged): ditto.
	(TabsSelect): ditto.
	(TabsPage): ditto.
	(TabsHighlight): ditto.
	(DrawTabs): ditto.
	(TabLayout): Caclulate rows for all children and whether they
	should be visible or not..
	(TabsShuffleRows): shuffle rows based on both real and displayed
	rows. Adjust visibility of all children.
	(PreferredSize): ditto.

2000-11-19  Martin Buchholz  <martin@xemacs.org>

	* xlwtabs.c (TabsResize): Don't delete `tab', mark unused instead.

2000-11-18  Martin Buchholz  <martin@xemacs.org>

	* xlwmenu.c (make_windows_if_needed): 
	(XlwMenuRealize): 
	The proper type for `mask' is `unsigned long', not `int'.

2000-11-18  Martin Buchholz  <martin@xemacs.org>

	* xlwtabs.c (defaultAccelerators): Add #### to unused var.
	(TabsResize): Remove unused var.
	* xlwmenu.c (XlwMenuInitialize): Remove unused vars.
	* lwlib-Xlw.c (xlw_update_one_widget): Add #### for probable bug.

2000-11-14  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.37 is released.

2000-11-02  Stephen J. Turnbull  <stephen@xemacs.org>

	* lwlib.h: Typo fixes and tiny clarifications.

2000-10-04  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.36 is released.

2000-09-21  Andy Piper  <andy@xemacs.org>

	* lwlib.h: declare copy_widget_value_tree.

	* lwlib.c (copy_widget_value_tree): make non-static.

2000-09-19  Martin Buchholz  <martin@xemacs.org>

	* *: Spelling mega-patch

2000-09-16  Martin Buchholz  <martin@xemacs.org>

	* lwlib.c (ascii_strcasecmp): New.
	* lwlib.c (find_in_table): Use ascii_strcasecmp.
	Avoid using non-standard non-portable strcasecmp.

2000-08-02  Stephen J. Turnbull <stephen@xemacs.org>

	* xlwmenu.c (XlwMenuInitialize): make comment on algorithm for
	setting fontList match code.  Suggest using same algorithm for
	X Font Set resources in native lw code.

2000-07-30  Ben Wing  <ben@xemacs.org>

	* lwlib-Xaw.c (xaw_update_one_widget):
	Remove accelerator specs from buttons, since Athena doesn't handle
	them.
	
	* lwlib.c (lw_remove_accelerator_spec):
	* lwlib.h:
	Define function and prototype to do this.

2000-07-15  Ben Wing  <ben@xemacs.org>

	* xlwradioP.h:
	Remove duplicate definition of streq().

2000-07-19  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.35 is released.

2000-07-09  Martin Buchholz  <martin@xemacs.org>

	* xlwcheckbox.c:
	* xlwgauge.h:
	* xlwgaugeP.h:
	* xlwradio.h:
	* xlwradioP.h:
	* xlwgauge.c:
	* config.h.in:
	* xlwradio.c:
	* lwlib-Xaw.c:
	Replace SMART_INCLUDE with a dumber, but more reliable method.

	* xlwmenu.c (parameterize_string): Fix C++ compilation warnings.

2000-06-10  Ben Wing  <ben@xemacs.org>

	* lwlib-Xaw.c (xaw_create_label): add sanity check on arg limit.
	(xaw_update_one_value): fix crash due to incorrect arg count.

2000-05-28  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.34 is released.

2000-05-01  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.33 is released.

2000-04-19  Martin Buchholz  <martin@xemacs.org>

	* lwlib.c (lw_destroy_everything): Always use full ANSI prototypes.
	* lwlib.c (lw_destroy_all_pop_ups): Always use full ANSI prototypes.

2000-04-12  Andy Piper  <andy@xemacs.org>

	* lwlib-Xaw.c (xaw_update_one_widget): no-op for text widgets.
	(xaw_update_one_value): Get strings safely.
	(xaw_create_text_field): add some extra properties.

2000-04-05  Andy Piper  <andy@xemacs.org>

	* lwlib-Xaw.c (lw_xaw_widget_p): include asciiTextWidgetClass as
	an athena widget.

2000-04-05  Andy Piper  <andy@xemacs.org>

	* xlwradio.c (RadioSetValues): resize if position information has
	changed.

	* lwlib-Xm.c (xm_create_text_field): text fields should be enabled
	even if there is no callback.
	* lwlib-Xaw.c (xaw_create_text_field): ditto.

2000-04-03  Andy Piper  <andy@xemacs.org>

	* lwlib.c (merge_widget_value_args): only merge when the two args
	are actually different.

2000-03-21  Didier Verna  <didier@xemacs.org>

	* config.h.in: move INCLUDE_GLUE_1 and INCLUDE_GLUE_2 to
	src/config.h.in.
	* config.h.in (ATHENA_INCLUDE): use the `SMART_INCLUDE' macro.

2000-03-20  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.32 is released.

2000-03-14  Ben Wing  <ben@xemacs.org>

	* xlwmenu.c (massage_resource_name): Handle %_ and %%.

2000-02-20  Gunnar Evermann  <ge204@eng.cam.ac.uk>

	* xlwscrollbar.c (get_gc): Always check for XmUNSPECIFIED_PIXMAP
	even if we are only 'compatible' with the Motif resources.
	(XmUNSPECIFIED_PIXMAP): Define unconditionally.

2000-02-23  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.31 is released.

2000-02-22  Andy Piper  <andy@xemacs.org>

	* lwlib-Xm.c (xm_update_one_widget): set widget args last in case
	anything messes with them in the meantime.
	* lwlib-Xlw.c (xlw_update_one_widget): ditto.
	* lwlib-Xaw.c (xaw_update_one_widget): ditto.

2000-02-21  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.30 is released.

2000-02-21  Andy Piper  <andy@xemacs.org>

	* lwlib.c (merge_widget_value_args): don't delete the args before
	copying, lw_copy_widget_value_args will do this for us if
	necessary.
	(lw_add_widget_value_arg): Allow existing args to be replaced.
	(free_widget_value_args): Set args to 0 rather than 0xdeadbeef,
	reference couting works better that way.
	(lw_copy_widget_value_args): Do the right thing.

	* lwlib-Xm.c (xm_create_progress): Make sensitive as this looks
	much better.
	* lwlib-Xaw.c (xaw_create_progress): ditto.

2000-02-12  Jan Vroonhof  <vroonhof@math.ethz.ch>

	* xlwmenu.h (XmUNSPECIFIED_PIXMAP): Define this if we are using Motif
	compatible resource names.

	* xlwmenu.c (make_shadow_gcs): Always check for XmUNSPECIFIED_PIXMAP
	even if we are only 'compatible' with the Motif resources.

2000-02-15  Andy Piper  <andy@xemacs.org>

	* xlwgauge.c (GaugeExpose): remove shadows.

2000-02-16  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.29 is released.

2000-02-09  Valdis Kletnieks  <Valdis.Kletnieks@vt.edu>

	* config.h.in (ATHENA_INCLUDE): Workaround bugs in both xlc and
	old gccs.

2000-02-07  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.28 is released.

2000-01-25  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c (TabsChangeManaged): Make sure we unmanage the hilight
	widget as well.

2000-01-28  Martin Buchholz  <martin@xemacs.org>

	* xlwgauge.c (GaugeConvert): bcopy ==> memcpy

2000-01-24  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c (XawTabsSetTop): Unhighlight before changing the
	stacking order.
	(XawTabsSetHighlight): Don't unhighlight here.

2000-01-22  Martin Buchholz  <martin@xemacs.org>

	* *.h: Use consistent C-standards-approved guard macro names.

2000-01-18  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.27 is released.

2000-01-15  Andy Piper  <andy@xemacs.org>

	* lwlib-Xlw.c (lw_update_one_widget): make sure global
	properties gets set.

2000-01-07  Martin Buchholz  <martin@xemacs.org>

	* config.h.in (ATHENA_INCLUDE): CPP trickery to make old cpps happy.
	This extends support for gcc 2.6 (e.g. on BSD/OS 2.0)

	* lwlib.c: Fix up memset calls.

	* lwlib-Xm.c (xm_update_text): Warning suppression.
	(xm_update_text_field): Warning suppression.

2000-01-03  Martin Buchholz  <martin@xemacs.org>

	* lwlib-Xaw.c (xaw_update_one_widget): Emergency fix for this crash:
	(yes-or-no-p-dialog-box "Yes or No")

1999-12-31  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.26 is released.

1999-12-29  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c (TabsHighlight): use displayChildren for highlighting
	not num_children.
	(TabsPage): ditto.

1999-12-24  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.25 is released.

1999-12-23  Andy Piper  <andy@xemacs.org>

	* lwlib.c (lw_copy_widget_value_args): don't create empty
	widget_args just because someone might use them later. This makes
	all widgets look like they've changed.

1999-12-22  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c: Fix for X11R5 from Damon Lipparelli
	<lipp@primus.com>.

1999-12-21  Martin Buchholz  <martin@xemacs.org>

	* xlwscrollbar.c (seg_pixel_sizes): ((expr)) ==> (expr)

1999-12-12  Daniel Pittman  <daniel@danann.net>

	* lwlib-Xaw.c:
	* xlwcheckbox.c:
	* xlwgauge.h:
	* xlwgaugeP.h:
	* xlwradio.c:
	* xlwradio.h:
	* xlwradioP.h:
	Clean up Athena widget support:
	- Athena headers now use dynamic include paths.

1999-12-08  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c: sync with Tabs 2.2.
	* xlwtabP.h: ditto.

1999-12-14  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.24 is released.

1999-12-14  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c (TabsResize): reset need_layout so that we don't go
	into infloop death.

1999-12-14  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c (TabsSetValues): re-allocate GCs if font has changed.

1999-12-13  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c (TabsResize): We need to expose the tabs after
	clearing the window they are in.

1999-12-08  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c: sync with Tabs 2.1.

1999-12-07  Andy Piper  <andy@xemacs.org>

	* lwlib-Xlw.c (lw_lucid_widget_p): make sure we pick up the
	clip-window as well.

1999-12-07  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.23 is released.

1999-12-05  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c: back up to previous rev to make syncing easier. Fix
	gcc moans.

	* lwlib-Xaw.c (xaw_update_one_widget): use XtIsSubclass.

1999-11-29  XEmacs Build Bot <builds@cvs.xemacs.org>

	* XEmacs 21.2.22 is released

1999-11-28  Martin Buchholz <martin@xemacs.org>

	* XEmacs 21.2.21 is released.

1999-11-26  Martin Buchholz  <martin@xemacs.org>

	* xlwtabs.c: Remove unused variables.  Fix warnings.

1999-11-10  XEmacs Build Bot <builds@cvs.xemacs.org>

	* XEmacs 21.2.20 is released

1999-09-09  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c: updated tabs widget from Ed Falk.
	* xlwtabs.h: ditto.
	* xlwtabsP.h: ditto.

1999-09-22  Martin Buchholz  <martin@xemacs.org>

	* lwlib-internal.h:
	* lwlib-utils.h:
	Move declaration of destroy_all_children from lwlib-internal.h to
	lwlib-utils.h, where it belongs.

1999-09-21  Andy Piper  <andy@xemacs.org>

	* lwlib-Xm.c (xm_update_label): don't clobber pixmap type labels
 	with text.

1999-09-22  Martin Buchholz  <martin@xemacs.org>

	* xlwtabs.c: Fix C++ compilability.

1999-09-18  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c: Put in tabs sync because clipping should fix useability
 	problems.

1999-09-13  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c: Back out tabs sync because of reported useability
 	problems.

1999-09-09  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c: updated tabs widget from Ed Falk.
	* xlwtabs.h: ditto.
	* xlwtabsP.h: ditto.
	* xlwgcs.c: ditto.
	* xlwgcs.h: ditto.

1999-09-03  Martin Buchholz  <martin@xemacs.org>

	* xlwgauge.c: Ansify.
	Include <stdlib.h> to get prototype for atoi().
	(GaugeSelect): Call GaugeExpose with the right number of args.
	(GaugeLoseSel): Call GaugeExpose with the right number of args.
	(GaugeConvert): This is a XtConvertSelectionProc,
	so 5th parameter must be of type XtPointer, not XPointer.
	(GaugeGetValue): This is a XtTimerCallbackProc,
	so 2nd parameter must be of type XtIntervalId *, not XtIntervalId.


1999-09-01  Martin Buchholz  <martin@xemacs.org>

	* lwlib.c (free_widget_value_contents): Use proper type for cast.

	* xlwradio.c: Use function prototypes everywhere.
	* xlwcheckbox.c:
	* xlwradio.c:
	* xlwradioP.h: Move declarations of non-static functions defined
	in xlwradio.c into xlwradioP.h.

1999-09-02  Andy Piper  <andy@xemacs.org>

	* xlwgcs.c: include xmu.h

1999-09-01  Andy Piper  <andy@xemacs.org>

	* xlwgauge.c: rearrange headers yet again.
	* xlwcheckbox.c: ditto.
	* xlwradio.c: ditto.
	* xlwtabs.c: ditto.

1999-09-01  Andy Piper  <andy@xemacs.org>

	* xlwgauge.c: use xmu.h
	* xlwcheckbox.c: ditto.
	* xlwradio.c: ditto.

1999-08-31  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c:
	* xlwgcs.c:
	* xlwradio.c:
	* xlwcheckbox.c:
	* xlwgauge.c: Fix for losing systems without Xmu.

1999-08-31  Andy Piper  <andy@xemacs.org>

	* lwlib-Xm.c (xm_update_one_widget): fix for AIX compiler lossage.

1999-08-30  Andy Piper  <andy@xemacs.org>

	* lwlib.c (free_widget_value_contents): be more precise about
 	freeing user defined args.

	* lwlib-Xaw.c (xaw_update_one_widget): make sure we use val not
 	its contents for hierarchies one deep.

1999-08-29  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c: temporary fixes pending a new release.
	* xlwtabsP.h: ditto.

	* lwlib-Xm.c (xm_update_one_widget): update user defined args.
	(xm_create_label): set args after creation as well as before.

	* lwlib-Xlw.c (xlw_create_tab_control): orient tabs horizontally.
	(xlw_update_tab_control): actually update the children rather than
 	the parent.

	* lwlib-Xaw.c (xaw_update_one_widget): update user defined args.
	(xaw_create_label): set args after creation as well as before.

1999-08-23  Andy Piper  <andy@xemacs.org>

	* lwlib-Xm.c (xm_update_label): don't concatenate value to itself.

	* lwlib-Xm.c (xm_create_label_field): new function for creating labels.
	(xm_creation_table): use it.

	* lwlib-Xaw.c (xaw_create_label_field): new function for creating labels.
	(xaw_creation_table): use it.

1999-08-16  Andy Piper  <andy@xemacs.org>

	* lwlib.h: declare free_widget_value_tree.

	* lwlib.c (free_widget_value_tree): make non-static.

	* lwlib-Xm.c (xm_update_label): free val_string when updating.

1999-08-04  Andy Piper  <andy@xemacs.org>

	* lwlib-Xm.c (mark_dead_instance_destroyed): change so that its
 	defined for widgets.
	(xm_nosel_callback): ditto.

	* xlwtabsP.h: sync with 1.5.

	* xlwtabs.c: sync with 1.18.

1999-07-28  Andy Piper  <andy@xemacs.org>

	* xlwtabs.c: new lucid tabs widget from Ed Falk.
	* xlwtabs.h: ditto.
	* xlwtabsP.h: ditto.
	* xlwgcs.c: GC manipulation for tab widgets.
	* xlwgcs.h: ditto.

	* xlwgauge.c: new athena gauge widget from Ed Falk.
	* xlwgauge.h: ditto.
	* xlwgaugeP.h: ditto.

	* xlwradio.c: new athena radio widget from Ed Falk.
	* xlwradio.h: ditto.
	* xlwradioP.h: ditto.

	* xlwcheckbox.c: new athena checkbox widget from Ed Falk.
	* xlwcheckbox.h: ditto.
	* xlwcheckboxP.h: ditto.

	* lwlib-utils.c (destroy_all_children): moved from lwlib-Xm.c.

	* lwlib-internal.h: declare destroy_all_children.

	* lwlib-config.c: add widget checks.

	* lwlib-Xm.h: declare xm_create_label;

	* lwlib-Xm.c (destroy_all_children): move to lwlib-utils.c.
	(xm_update_label): enable for widgets.
	(xm_update_one_widget): ditto.
	(xm_create_button): rename in line with lwlib-Xaw.c
	(xm_create_progress): ditto.
	(xm_create_text_field): ditto.
	(xm_create_combo_box): ditto.
	(xm_create_label): new function.
	(xm_creation_table): rename widget creation functions.
	(xm_destroy_instance): enable for widgets.
	(xm_generic_callback): ditto.
	(xm_generic_callback): ditto.

	* lwlib-Xlw.c (xlw_tab_control_callback): new function. a special
 	callback that calls the correct function depending on what tab is
 	selected.
	(xlw_create_tab_control): new function.
	(build_tabs_in_widget): new function. puts tabs in a tab widget,
 	uses Xaw or Xm depending on how XEmacs was compiled.
	(xlw_update_tab_control): update the resources for each
 	tab. optionally rebuild the contents of the tab widget.
	(xlw_creation_table): add tab widget creation function.
	(lw_lucid_widget_p): add tab widget.
	(xlw_update_one_widget): ditto.

	* lwlib-Xaw.h: declare xaw_create_label;

	* lwlib-Xaw.c (lw_xaw_widget_p): add widgets classes.
	(xaw_update_one_widget): ditto.
	(xaw_update_one_value): add code from the Xm version.
	(xaw_generic_callback): add Xm hack for setting command
 	states. beef up lookup of call data.
	(xaw_create_button): new function.
	(xaw_create_label): new function for use by tab widget.
	(xaw_create_progress): new function.
	(xaw_create_text_field): new function.
	(xaw_creation_table): add new widget type creation functions.

	* Makefile.in.in: add dependencies for new lw widgets.

1999-07-30  XEmacs Build Bot <builds@cvs.xemacs.org>

	* XEmacs 21.2.19 is released

1999-07-13  XEmacs Build Bot <builds@cvs.xemacs.org>

	* XEmacs 21.2.18 is released

1999-07-05  Didier Verna  <didier@xemacs.org>

	* lwlib-Xm.c (xm_update_one_widget): add missing #ifdefs around
	call to xm_update_label.

1999-06-28  Andy Piper  <andy@xemacs.org>

	* lwlib-Xm.c: unconditionally enable text field & list code.
	(make_progress): new function. creates a slider.
	(make_text_field): new function. creates an edit field.
	(make_combo_box): new function. creates a combo box.
	(xm_creation_table): add new widget functions.

1999-06-25  Andy Piper  <andy@xemacs.org>

	* lwlib.h (_widget_value): add arglist slots.
	declare new functions.

	* lwlib.c (free_widget_value_contents): handle arglists when
 	freeing.
	(lw_add_value_args_to_args): new function. add arglist entries
 	from a widget_value structure.

	* lwlib-Xm.c (make_button): new function, create a motif button
 	for display in a buffer as a glyph.
	(xm_creation_table): add make_button.

1999-06-22  XEmacs Build Bot <builds@cvs.xemacs.org>

	* XEmacs 21.2.17 is released

1999-06-11  XEmacs Build Bot <builds@cvs.xemacs.org>

	* XEmacs 21.2.16 is released

1999-06-04  XEmacs Build Bot <builds@cvs.xemacs.org>

	* XEmacs 21.2.15 is released

1999-05-17  Jerry James  <jerry@cs.ucsb.edu>

	* xlwmenu.c (make_shadow_gcs): Test bottom_shadow_pixmap before
	using it.

1999-05-14  XEmacs Build Bot <builds@cvs.xemacs.org>

	* XEmacs 21.2.14 is released

1999-03-12  XEmacs Build Bot <builds@cvs.xemacs.org>

	* XEmacs 21.2.13 is released

1999-03-05  XEmacs Build Bot <builds@cvs.xemacs.org>

	* XEmacs 21.2.12 is released

1999-02-18  Martin Buchholz  <martin@xemacs.org>

	* lwlib/xlwmenu.c (massage_resource_name): Fix compiler warning
	- Have to toupper ((int) (unsigned char) x) to be portable.


ChangeLog entries synched from GNU Emacs are the property of the FSF.
Other ChangeLog entries are usually the property of the author of the
change.

This file is part of XEmacs.

XEmacs is free software: you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation, either version 3 of the License, or (at your
option) any later version.

XEmacs is distributed in the hope that it will be useful, but WITHOUT
ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
for more details.

You should have received a copy of the GNU General Public License
along with XEmacs.  If not, see <http://www.gnu.org/licenses/>.
